diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index f4faffc..812e8af 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -659,53 +659,9 @@ config TARGET_VF610TWR
 config ZYNQ
 	bool "Xilinx Zynq Platform"
 
-config TARGET_MEDCOM_WIDE
-	bool "Support medcom-wide"
-
-config TARGET_PLUTUX
-	bool "Support plutux"
-
-config TARGET_TEC
-	bool "Support tec"
-
-config TARGET_PAZ00
-	bool "Support paz00"
-
-config TARGET_TRIMSLICE
-	bool "Support trimslice"
-
-config TARGET_HARMONY
-	bool "Support harmony"
-
-config TARGET_SEABOARD
-	bool "Support seaboard"
-
-config TARGET_VENTANA
-	bool "Support ventana"
-
-config TARGET_WHISTLER
-	bool "Support whistler"
-
-config TARGET_COLIBRI_T20_IRIS
-	bool "Support colibri_t20_iris"
-
-config TARGET_TEC_NG
-	bool "Support tec-ng"
-
-config TARGET_BEAVER
-	bool "Support beaver"
-
-config TARGET_CARDHU
-	bool "Support cardhu"
-
-config TARGET_DALMORE
-	bool "Support dalmore"
-
-config TARGET_JETSON_TK1
-	bool "Support jetson-tk1"
-
-config TARGET_VENICE2
-	bool "Support venice2"
+config TEGRA
+	bool "NVIDIA Tegra"
+	select SPL
 
 config TARGET_VEXPRESS_AEMV8A
 	bool "Support vexpress_aemv8a"
@@ -760,7 +716,10 @@ config TARGET_JORNADA
 
 endchoice
 
+source "arch/arm/cpu/armv7/tegra-common/Kconfig"
+
 source "arch/arm/cpu/armv7/zynq/Kconfig"
+
 source "board/8dtech/eco5pk/Kconfig"
 source "board/Barix/ipam390/Kconfig"
 source "board/BuR/kwb/Kconfig"
@@ -802,10 +761,6 @@ source "board/atmel/at91sam9rlek/Kconfig"
 source "board/atmel/at91sam9x5ek/Kconfig"
 source "board/atmel/sama5d3_xplained/Kconfig"
 source "board/atmel/sama5d3xek/Kconfig"
-source "board/avionic-design/medcom-wide/Kconfig"
-source "board/avionic-design/plutux/Kconfig"
-source "board/avionic-design/tec-ng/Kconfig"
-source "board/avionic-design/tec/Kconfig"
 source "board/balloon3/Kconfig"
 source "board/barco/titanium/Kconfig"
 source "board/bluegiga/apx4devkit/Kconfig"
@@ -821,11 +776,9 @@ source "board/cloudengines/pogo_e02/Kconfig"
 source "board/cm4008/Kconfig"
 source "board/cm41xx/Kconfig"
 source "board/comelit/dig297/Kconfig"
-source "board/compal/paz00/Kconfig"
 source "board/compulab/cm_t335/Kconfig"
 source "board/compulab/cm_t35/Kconfig"
 source "board/compulab/cm_t54/Kconfig"
-source "board/compulab/trimslice/Kconfig"
 source "board/congatec/cgtqmx6eval/Kconfig"
 source "board/corscience/tricorder/Kconfig"
 source "board/creative/xfi3/Kconfig"
@@ -896,15 +849,6 @@ source "board/logicpd/zoom1/Kconfig"
 source "board/matrix_vision/mvblx/Kconfig"
 source "board/mpl/vcma9/Kconfig"
 source "board/nokia/rx51/Kconfig"
-source "board/nvidia/beaver/Kconfig"
-source "board/nvidia/cardhu/Kconfig"
-source "board/nvidia/dalmore/Kconfig"
-source "board/nvidia/harmony/Kconfig"
-source "board/nvidia/jetson-tk1/Kconfig"
-source "board/nvidia/seaboard/Kconfig"
-source "board/nvidia/venice2/Kconfig"
-source "board/nvidia/ventana/Kconfig"
-source "board/nvidia/whistler/Kconfig"
 source "board/olimex/mx23_olinuxino/Kconfig"
 source "board/omicron/calimain/Kconfig"
 source "board/overo/Kconfig"
@@ -976,7 +920,6 @@ source "board/ti/tnetv107xevm/Kconfig"
 source "board/timll/devkit3250/Kconfig"
 source "board/timll/devkit8000/Kconfig"
 source "board/toradex/colibri_pxa270/Kconfig"
-source "board/toradex/colibri_t20_iris/Kconfig"
 source "board/trizepsiv/Kconfig"
 source "board/ttcontrol/vision2/Kconfig"
 source "board/udoo/Kconfig"
diff --git a/arch/arm/cpu/armv7/tegra-common/Kconfig b/arch/arm/cpu/armv7/tegra-common/Kconfig
new file mode 100644
index 0000000..8e2153b
--- /dev/null
+++ b/arch/arm/cpu/armv7/tegra-common/Kconfig
@@ -0,0 +1,30 @@
+if TEGRA
+
+choice
+	prompt "Tegra SoC select"
+
+config TEGRA20
+	bool "Tegra20 family"
+
+config TEGRA30
+	bool "Tegra30 family"
+
+config TEGRA114
+	bool "Tegra114 family"
+
+config TEGRA124
+	bool "Tegra124 family"
+
+endchoice
+
+config SYS_CPU
+	string
+	default "arm720t" if SPL_BUILD
+	default "armv7" if !SPL_BUILD
+
+source "arch/arm/cpu/armv7/tegra20/Kconfig"
+source "arch/arm/cpu/armv7/tegra30/Kconfig"
+source "arch/arm/cpu/armv7/tegra114/Kconfig"
+source "arch/arm/cpu/armv7/tegra124/Kconfig"
+
+endif
diff --git a/arch/arm/cpu/armv7/tegra114/Kconfig b/arch/arm/cpu/armv7/tegra114/Kconfig
new file mode 100644
index 0000000..2468c0b
--- /dev/null
+++ b/arch/arm/cpu/armv7/tegra114/Kconfig
@@ -0,0 +1,17 @@
+if TEGRA114
+
+choice
+	prompt "Tegra114 board select"
+
+config TARGET_DALMORE
+	bool "Dalmore board"
+
+endchoice
+
+config SYS_SOC
+	string
+	default "tegra114"
+
+source "board/nvidia/dalmore/Kconfig"
+
+endif
diff --git a/arch/arm/cpu/armv7/tegra124/Kconfig b/arch/arm/cpu/armv7/tegra124/Kconfig
new file mode 100644
index 0000000..e770f7f
--- /dev/null
+++ b/arch/arm/cpu/armv7/tegra124/Kconfig
@@ -0,0 +1,21 @@
+if TEGRA124
+
+choice
+	prompt "Tegra124 board select"
+
+config TARGET_JETSON_TK1
+	bool "Jetson-tk1 board"
+
+config TARGET_VENICE2
+	bool "Venice2 board"
+
+endchoice
+
+config SYS_SOC
+	string
+	default "tegra124"
+
+source "board/nvidia/jetson-tk1/Kconfig"
+source "board/nvidia/venice2/Kconfig"
+
+endif
diff --git a/arch/arm/cpu/armv7/tegra20/Kconfig b/arch/arm/cpu/armv7/tegra20/Kconfig
new file mode 100644
index 0000000..b6d5b5a
--- /dev/null
+++ b/arch/arm/cpu/armv7/tegra20/Kconfig
@@ -0,0 +1,53 @@
+if TEGRA20
+
+choice
+	prompt "Tegra20 board select"
+
+config TARGET_HARMONY
+	bool "Harmony board"
+
+config TARGET_MEDCOM_WIDE
+	bool "Medcom-wide board"
+
+config TARGET_PAZ00
+	bool "Paz00 board"
+
+config TARGET_PLUTUX
+	bool "Plutux board"
+
+config TARGET_SEABOARD
+	bool "Seaboard board"
+
+config TARGET_TEC
+	bool "Tec board"
+
+config TARGET_TRIMSLICE
+	bool "Trimslice board"
+
+config TARGET_VENTANA
+	bool "Ventana board"
+
+config TARGET_WHISTLER
+	bool "Whistler board"
+
+config TARGET_COLIBRI_T20_IRIS
+	bool "Colibri_t20_iris board"
+
+endchoice
+
+config SYS_SOC
+	string
+	default "tegra20"
+
+source "board/nvidia/harmony/Kconfig"
+source "board/avionic-design/medcom-wide/Kconfig"
+source "board/compal/paz00/Kconfig"
+source "board/avionic-design/plutux/Kconfig"
+source "board/nvidia/seaboard/Kconfig"
+source "board/avionic-design/tec/Kconfig"
+source "board/compulab/trimslice/Kconfig"
+source "board/nvidia/ventana/Kconfig"
+source "board/nvidia/whistler/Kconfig"
+source "board/toradex/colibri_t20_iris/Kconfig"
+
+endif
diff --git a/arch/arm/cpu/armv7/tegra30/Kconfig b/arch/arm/cpu/armv7/tegra30/Kconfig
new file mode 100644
index 0000000..8570e97
--- /dev/null
+++ b/arch/arm/cpu/armv7/tegra30/Kconfig
@@ -0,0 +1,25 @@
+if TEGRA30
+
+choice
+	prompt "Tegra30 board select"
+
+config TARGET_BEAVER
+	bool "Beaver board"
+
+config TARGET_CARDHU
+	bool "Cardhu board"
+
+config TARGET_TEC_NG
+	bool "Tec-ng board"
+
+endchoice
+
+config SYS_SOC
+	string
+	default "tegra30"
+
+source "board/nvidia/beaver/Kconfig"
+source "board/nvidia/cardhu/Kconfig"
+source "board/avionic-design/tec-ng/Kconfig"
+
+endif
diff --git a/arch/arm/include/asm/arch-tegra114/tegra.h b/arch/arm/include/asm/arch-tegra114/tegra.h
index 705ca57..5d426b5 100644
--- a/arch/arm/include/asm/arch-tegra114/tegra.h
+++ b/arch/arm/include/asm/arch-tegra114/tegra.h
@@ -17,8 +17,6 @@
 #ifndef _TEGRA114_H_
 #define _TEGRA114_H_
 
-#define CONFIG_TEGRA114
-
 #define NV_PA_SDRAM_BASE	0x80000000	/* 0x80000000 for real T114 */
 #define NV_PA_TSC_BASE		0x700F0000	/* System Counter TSC regs */
 
diff --git a/arch/arm/include/asm/arch-tegra124/tegra.h b/arch/arm/include/asm/arch-tegra124/tegra.h
index 86ebd19..db3d837 100644
--- a/arch/arm/include/asm/arch-tegra124/tegra.h
+++ b/arch/arm/include/asm/arch-tegra124/tegra.h
@@ -8,8 +8,6 @@
 #ifndef _TEGRA124_H_
 #define _TEGRA124_H_
 
-#define CONFIG_TEGRA124
-
 #define NV_PA_SDRAM_BASE	0x80000000
 #define NV_PA_TSC_BASE		0x700F0000	/* System Counter TSC regs */
 #define NV_PA_MC_BASE		0x70019000	/* Mem Ctlr regs (MCB, etc.) */
diff --git a/arch/arm/include/asm/arch-tegra20/tegra.h b/arch/arm/include/asm/arch-tegra20/tegra.h
index 6a4b40e..18856ac 100644
--- a/arch/arm/include/asm/arch-tegra20/tegra.h
+++ b/arch/arm/include/asm/arch-tegra20/tegra.h
@@ -8,8 +8,6 @@
 #ifndef _TEGRA20_H_
 #define _TEGRA20_H_
 
-#define CONFIG_TEGRA20
-
 #define NV_PA_SDRAM_BASE	0x00000000
 
 #include <asm/arch-tegra/tegra.h>
diff --git a/arch/arm/include/asm/arch-tegra30/tegra.h b/arch/arm/include/asm/arch-tegra30/tegra.h
index 4ad8b1c..c02c5d8 100644
--- a/arch/arm/include/asm/arch-tegra30/tegra.h
+++ b/arch/arm/include/asm/arch-tegra30/tegra.h
@@ -17,8 +17,6 @@
 #ifndef _TEGRA30_H_
 #define _TEGRA30_H_
 
-#define CONFIG_TEGRA30
-
 #define NV_PA_SDRAM_BASE	0x80000000	/* 0x80000000 for real T30 */
 
 #include <asm/arch-tegra/tegra.h>
diff --git a/board/avionic-design/medcom-wide/Kconfig b/board/avionic-design/medcom-wide/Kconfig
index 2472fe2..16001e4 100644
--- a/board/avionic-design/medcom-wide/Kconfig
+++ b/board/avionic-design/medcom-wide/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_MEDCOM_WIDE
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "medcom-wide"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "avionic-design"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "medcom-wide"
diff --git a/board/avionic-design/plutux/Kconfig b/board/avionic-design/plutux/Kconfig
index a697a54..c9a90247 100644
--- a/board/avionic-design/plutux/Kconfig
+++ b/board/avionic-design/plutux/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_PLUTUX
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "plutux"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "avionic-design"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "plutux"
diff --git a/board/avionic-design/tec-ng/Kconfig b/board/avionic-design/tec-ng/Kconfig
index f52edda..e6b69e8 100644
--- a/board/avionic-design/tec-ng/Kconfig
+++ b/board/avionic-design/tec-ng/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_TEC_NG
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "tec-ng"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "avionic-design"
 
-config SYS_SOC
-	string
-	default "tegra30"
-
 config SYS_CONFIG_NAME
 	string
 	default "tec-ng"
diff --git a/board/avionic-design/tec/Kconfig b/board/avionic-design/tec/Kconfig
index d19e3f4..fbf7f46 100644
--- a/board/avionic-design/tec/Kconfig
+++ b/board/avionic-design/tec/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_TEC
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "tec"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "avionic-design"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "tec"
diff --git a/board/compal/paz00/Kconfig b/board/compal/paz00/Kconfig
index 4f0f09f..690d7a7 100644
--- a/board/compal/paz00/Kconfig
+++ b/board/compal/paz00/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_PAZ00
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "paz00"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "compal"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "paz00"
diff --git a/board/compulab/trimslice/Kconfig b/board/compulab/trimslice/Kconfig
index e545f0c..6ae030c 100644
--- a/board/compulab/trimslice/Kconfig
+++ b/board/compulab/trimslice/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_TRIMSLICE
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "trimslice"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "compulab"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "trimslice"
diff --git a/board/nvidia/beaver/Kconfig b/board/nvidia/beaver/Kconfig
index f052676..e487b66 100644
--- a/board/nvidia/beaver/Kconfig
+++ b/board/nvidia/beaver/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_BEAVER
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "beaver"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra30"
-
 config SYS_CONFIG_NAME
 	string
 	default "beaver"
diff --git a/board/nvidia/cardhu/Kconfig b/board/nvidia/cardhu/Kconfig
index 9853114..150815f 100644
--- a/board/nvidia/cardhu/Kconfig
+++ b/board/nvidia/cardhu/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_CARDHU
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "cardhu"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra30"
-
 config SYS_CONFIG_NAME
 	string
 	default "cardhu"
diff --git a/board/nvidia/dalmore/Kconfig b/board/nvidia/dalmore/Kconfig
index 33b78db..9eed19c 100644
--- a/board/nvidia/dalmore/Kconfig
+++ b/board/nvidia/dalmore/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_DALMORE
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "dalmore"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra114"
-
 config SYS_CONFIG_NAME
 	string
 	default "dalmore"
diff --git a/board/nvidia/harmony/Kconfig b/board/nvidia/harmony/Kconfig
index 2a3bde4..7d75f2d 100644
--- a/board/nvidia/harmony/Kconfig
+++ b/board/nvidia/harmony/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_HARMONY
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "harmony"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "harmony"
diff --git a/board/nvidia/jetson-tk1/Kconfig b/board/nvidia/jetson-tk1/Kconfig
index 22b4c69..02b46b7 100644
--- a/board/nvidia/jetson-tk1/Kconfig
+++ b/board/nvidia/jetson-tk1/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_JETSON_TK1
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "jetson-tk1"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra124"
-
 config SYS_CONFIG_NAME
 	string
 	default "jetson-tk1"
diff --git a/board/nvidia/seaboard/Kconfig b/board/nvidia/seaboard/Kconfig
index 39c65b5..7863702 100644
--- a/board/nvidia/seaboard/Kconfig
+++ b/board/nvidia/seaboard/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_SEABOARD
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "seaboard"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "seaboard"
diff --git a/board/nvidia/venice2/Kconfig b/board/nvidia/venice2/Kconfig
index 84a7160..993da79 100644
--- a/board/nvidia/venice2/Kconfig
+++ b/board/nvidia/venice2/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_VENICE2
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "venice2"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra124"
-
 config SYS_CONFIG_NAME
 	string
 	default "venice2"
diff --git a/board/nvidia/ventana/Kconfig b/board/nvidia/ventana/Kconfig
index 59e85c4..95840a8 100644
--- a/board/nvidia/ventana/Kconfig
+++ b/board/nvidia/ventana/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_VENTANA
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "ventana"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "ventana"
diff --git a/board/nvidia/whistler/Kconfig b/board/nvidia/whistler/Kconfig
index f025413..113e2ef 100644
--- a/board/nvidia/whistler/Kconfig
+++ b/board/nvidia/whistler/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_WHISTLER
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "whistler"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "nvidia"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "whistler"
diff --git a/board/toradex/colibri_t20_iris/Kconfig b/board/toradex/colibri_t20_iris/Kconfig
index 334b7e0..cccdd58 100644
--- a/board/toradex/colibri_t20_iris/Kconfig
+++ b/board/toradex/colibri_t20_iris/Kconfig
@@ -1,10 +1,5 @@
 if TARGET_COLIBRI_T20_IRIS
 
-config SYS_CPU
-	string
-	default "arm720t" if SPL_BUILD
-	default "armv7" if !SPL_BUILD
-
 config SYS_BOARD
 	string
 	default "colibri_t20_iris"
@@ -13,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "toradex"
 
-config SYS_SOC
-	string
-	default "tegra20"
-
 config SYS_CONFIG_NAME
 	string
 	default "colibri_t20_iris"
diff --git a/configs/beaver_defconfig b/configs/beaver_defconfig
index 0e70f25..7c9d94b 100644
--- a/configs/beaver_defconfig
+++ b/configs/beaver_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA30=y
 +S:CONFIG_TARGET_BEAVER=y
diff --git a/configs/cardhu_defconfig b/configs/cardhu_defconfig
index 564ad5a..bb042b4 100644
--- a/configs/cardhu_defconfig
+++ b/configs/cardhu_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA30=y
 +S:CONFIG_TARGET_CARDHU=y
diff --git a/configs/colibri_t20_iris_defconfig b/configs/colibri_t20_iris_defconfig
index 8ff2464..b2a21e1 100644
--- a/configs/colibri_t20_iris_defconfig
+++ b/configs/colibri_t20_iris_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_COLIBRI_T20_IRIS=y
diff --git a/configs/dalmore_defconfig b/configs/dalmore_defconfig
index 288b238..70677aa 100644
--- a/configs/dalmore_defconfig
+++ b/configs/dalmore_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA114=y
 +S:CONFIG_TARGET_DALMORE=y
diff --git a/configs/harmony_defconfig b/configs/harmony_defconfig
index d25ea5c..a52231b 100644
--- a/configs/harmony_defconfig
+++ b/configs/harmony_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_HARMONY=y
diff --git a/configs/jetson-tk1_defconfig b/configs/jetson-tk1_defconfig
index 6926257..00eac92 100644
--- a/configs/jetson-tk1_defconfig
+++ b/configs/jetson-tk1_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA124=y
 +S:CONFIG_TARGET_JETSON_TK1=y
diff --git a/configs/medcom-wide_defconfig b/configs/medcom-wide_defconfig
index ddf3437..e9a3930 100644
--- a/configs/medcom-wide_defconfig
+++ b/configs/medcom-wide_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_MEDCOM_WIDE=y
diff --git a/configs/paz00_defconfig b/configs/paz00_defconfig
index 61a536e..05974eb 100644
--- a/configs/paz00_defconfig
+++ b/configs/paz00_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_PAZ00=y
diff --git a/configs/plutux_defconfig b/configs/plutux_defconfig
index 672b66c..60e80ff 100644
--- a/configs/plutux_defconfig
+++ b/configs/plutux_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_PLUTUX=y
diff --git a/configs/seaboard_defconfig b/configs/seaboard_defconfig
index c0f078b..516e760 100644
--- a/configs/seaboard_defconfig
+++ b/configs/seaboard_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_SEABOARD=y
diff --git a/configs/tec-ng_defconfig b/configs/tec-ng_defconfig
index 2360d25..e4a31cc 100644
--- a/configs/tec-ng_defconfig
+++ b/configs/tec-ng_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA30=y
 +S:CONFIG_TARGET_TEC_NG=y
diff --git a/configs/tec_defconfig b/configs/tec_defconfig
index 1aaa9d1..62a9542 100644
--- a/configs/tec_defconfig
+++ b/configs/tec_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_TEC=y
diff --git a/configs/trimslice_defconfig b/configs/trimslice_defconfig
index c096c65..94f23e3 100644
--- a/configs/trimslice_defconfig
+++ b/configs/trimslice_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_TRIMSLICE=y
diff --git a/configs/venice2_defconfig b/configs/venice2_defconfig
index 2bfa91d..dfc5407 100644
--- a/configs/venice2_defconfig
+++ b/configs/venice2_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA124=y
 +S:CONFIG_TARGET_VENICE2=y
diff --git a/configs/ventana_defconfig b/configs/ventana_defconfig
index 75fca96..845e241 100644
--- a/configs/ventana_defconfig
+++ b/configs/ventana_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_VENTANA=y
diff --git a/configs/whistler_defconfig b/configs/whistler_defconfig
index cdc2c90..8c07c18 100644
--- a/configs/whistler_defconfig
+++ b/configs/whistler_defconfig
@@ -1,3 +1,4 @@
-CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_TEGRA=y
++S:CONFIG_TEGRA20=y
 +S:CONFIG_TARGET_WHISTLER=y
diff --git a/include/configs/tegra-common.h b/include/configs/tegra-common.h
index 717cd61..d27fceb 100644
--- a/include/configs/tegra-common.h
+++ b/include/configs/tegra-common.h
@@ -14,7 +14,6 @@
  * High Level Configuration Options
  */
 #define CONFIG_ARMCORTEXA9		/* This is an ARM V7 CPU core */
-#define CONFIG_TEGRA			/* which is a Tegra generic machine */
 #define CONFIG_SYS_L2CACHE_OFF		/* No L2 cache */
 
 #include <asm/arch/tegra.h>		/* get chip and board defs */