diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index e3b49bb..8b3b7f7 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -131,53 +131,10 @@ config TARGET_TAURUS
 config TARGET_STAMP9G20
 	bool "Support stamp9g20"
 
-config TARGET_CAM_ENC_4XX
-	bool "Support cam_enc_4xx"
-
-config TARGET_IPAM390
-	bool "Support ipam390"
-
-config TARGET_DA830EVM
-	bool "Support da830evm"
-
-config TARGET_DA850EVM
-	bool "Support da850evm"
-
-config TARGET_HAWKBOARD
-	bool "Support hawkboard"
-
-config TARGET_DAVINCI_DM355EVM
-	bool "Support davinci_dm355evm"
-
-config TARGET_DAVINCI_DM355LEOPARD
-	bool "Support davinci_dm355leopard"
-
-config TARGET_DAVINCI_DM365EVM
-	bool "Support davinci_dm365evm"
-
-config TARGET_DAVINCI_DM6467EVM
-	bool "Support davinci_dm6467evm"
-
-config TARGET_DAVINCI_DVEVM
-	bool "Support davinci_dvevm"
-
-config TARGET_EA20
-	bool "Support ea20"
-
-config TARGET_DAVINCI_SCHMOOGIE
-	bool "Support davinci_schmoogie"
-
-config TARGET_DAVINCI_SFFSDR
-	bool "Support davinci_sffsdr"
-
-config TARGET_DAVINCI_SONATA
-	bool "Support davinci_sonata"
-
-config TARGET_ENBW_CMC
-	bool "Support enbw_cmc"
-
-config TARGET_CALIMAIN
-	bool "Support calimain"
+config ARCH_DAVINCI
+	bool "TI DaVinci"
+	help
+	  Support for TI's DaVinci platform.
 
 config KIRKWOOD
 	bool "Marvell Kirkwood"
@@ -620,6 +577,8 @@ config TARGET_JORNADA
 
 endchoice
 
+source "arch/arm/cpu/arm926ejs/davinci/Kconfig"
+
 source "arch/arm/cpu/armv7/exynos/Kconfig"
 
 source "arch/arm/cpu/arm926ejs/kirkwood/Kconfig"
@@ -633,7 +592,6 @@ source "arch/arm/cpu/arm926ejs/versatile/Kconfig"
 source "arch/arm/cpu/armv7/zynq/Kconfig"
 
 source "board/8dtech/eco5pk/Kconfig"
-source "board/Barix/ipam390/Kconfig"
 source "board/BuR/kwb/Kconfig"
 source "board/BuR/tseries/Kconfig"
 source "board/BuS/eb_cpux9k2/Kconfig"
@@ -644,7 +602,6 @@ source "board/Marvell/aspenite/Kconfig"
 source "board/Marvell/dkb/Kconfig"
 source "board/Marvell/gplugd/Kconfig"
 source "board/afeb9260/Kconfig"
-source "board/ait/cam_enc_4xx/Kconfig"
 source "board/altera/socfpga/Kconfig"
 source "board/armadeus/apf27/Kconfig"
 source "board/armltd/integrator/Kconfig"
@@ -680,22 +637,11 @@ source "board/congatec/cgtqmx6eval/Kconfig"
 source "board/corscience/tricorder/Kconfig"
 source "board/creative/xfi3/Kconfig"
 source "board/davedenx/qong/Kconfig"
-source "board/davinci/da8xxevm/Kconfig"
-source "board/davinci/dm355evm/Kconfig"
-source "board/davinci/dm355leopard/Kconfig"
-source "board/davinci/dm365evm/Kconfig"
-source "board/davinci/dm6467evm/Kconfig"
-source "board/davinci/dvevm/Kconfig"
-source "board/davinci/ea20/Kconfig"
-source "board/davinci/schmoogie/Kconfig"
-source "board/davinci/sffsdr/Kconfig"
-source "board/davinci/sonata/Kconfig"
 source "board/denx/m28evk/Kconfig"
 source "board/denx/m53evk/Kconfig"
 source "board/egnite/ethernut5/Kconfig"
 source "board/embest/mx6boards/Kconfig"
 source "board/emk/top9000/Kconfig"
-source "board/enbw/enbw_cmc/Kconfig"
 source "board/esd/meesc/Kconfig"
 source "board/esd/otc570/Kconfig"
 source "board/esg/ima3-mx53/Kconfig"
@@ -742,7 +688,6 @@ source "board/matrix_vision/mvblx/Kconfig"
 source "board/mpl/vcma9/Kconfig"
 source "board/nokia/rx51/Kconfig"
 source "board/olimex/mx23_olinuxino/Kconfig"
-source "board/omicron/calimain/Kconfig"
 source "board/overo/Kconfig"
 source "board/palmld/Kconfig"
 source "board/palmtc/Kconfig"
diff --git a/arch/arm/cpu/arm926ejs/davinci/Kconfig b/arch/arm/cpu/arm926ejs/davinci/Kconfig
new file mode 100644
index 0000000..be1b0f9
--- /dev/null
+++ b/arch/arm/cpu/arm926ejs/davinci/Kconfig
@@ -0,0 +1,79 @@
+if ARCH_DAVINCI
+
+choice
+	prompt "DaVinci board select"
+
+config TARGET_ENBW_CMC
+	bool "EnBW CMC board"
+
+config TARGET_IPAM390
+	bool "IPAM390 board"
+
+config TARGET_DA830EVM
+	bool "DA830 EVM board"
+
+config TARGET_DA850EVM
+	bool "DA850 EVM board"
+
+config TARGET_CAM_ENC_4XX
+	bool "CAM ENC 4xx board"
+
+config TARGET_HAWKBOARD
+	bool "Hawkboard"
+
+config TARGET_DAVINCI_DM355EVM
+	bool "DM355 EVM board"
+
+config TARGET_DAVINCI_DM355LEOPARD
+	bool "DM355 Leopard board"
+
+config TARGET_DAVINCI_DM365EVM
+	bool "DM365 EVM board"
+
+config TARGET_DAVINCI_DM6467EVM
+	bool "DM6467 EVM board"
+
+config TARGET_DAVINCI_DVEVM
+	bool "DVEVM board"
+
+config TARGET_EA20
+	bool "EA20 board"
+
+config TARGET_DAVINCI_SCHMOOGIE
+	bool "Schmoogie board"
+
+config TARGET_DAVINCI_SFFSDR
+	bool "SFFSDR board"
+
+config TARGET_DAVINCI_SONATA
+	bool "Sonata board"
+
+config TARGET_CALIMAIN
+	bool "Calimain board"
+
+endchoice
+
+config SYS_CPU
+	string
+	default "arm926ejs"
+
+config SYS_SOC
+	string
+	default "davinci"
+
+source "board/enbw/enbw_cmc/Kconfig"
+source "board/ait/cam_enc_4xx/Kconfig"
+source "board/Barix/ipam390/Kconfig"
+source "board/davinci/da8xxevm/Kconfig"
+source "board/davinci/dm355evm/Kconfig"
+source "board/davinci/dm355leopard/Kconfig"
+source "board/davinci/dm365evm/Kconfig"
+source "board/davinci/dm6467evm/Kconfig"
+source "board/davinci/dvevm/Kconfig"
+source "board/davinci/ea20/Kconfig"
+source "board/davinci/schmoogie/Kconfig"
+source "board/davinci/sffsdr/Kconfig"
+source "board/davinci/sonata/Kconfig"
+source "board/omicron/calimain/Kconfig"
+
+endif
diff --git a/board/Barix/ipam390/Kconfig b/board/Barix/ipam390/Kconfig
index a8134479..588ee73 100644
--- a/board/Barix/ipam390/Kconfig
+++ b/board/Barix/ipam390/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_IPAM390
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "ipam390"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "Barix"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "ipam390"
diff --git a/board/ait/cam_enc_4xx/Kconfig b/board/ait/cam_enc_4xx/Kconfig
index d1f89df..2b88692 100644
--- a/board/ait/cam_enc_4xx/Kconfig
+++ b/board/ait/cam_enc_4xx/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_CAM_ENC_4XX
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "cam_enc_4xx"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "ait"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "cam_enc_4xx"
diff --git a/board/davinci/da8xxevm/Kconfig b/board/davinci/da8xxevm/Kconfig
index 89f78d7..b123703 100644
--- a/board/davinci/da8xxevm/Kconfig
+++ b/board/davinci/da8xxevm/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DA830EVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "da8xxevm"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "da830evm"
@@ -24,10 +16,6 @@ endif
 
 if TARGET_DA850EVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "da8xxevm"
@@ -36,10 +24,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "da850evm"
@@ -48,10 +32,6 @@ endif
 
 if TARGET_HAWKBOARD
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "da8xxevm"
@@ -60,10 +40,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "hawkboard"
diff --git a/board/davinci/dm355evm/Kconfig b/board/davinci/dm355evm/Kconfig
index 2dbb509..7490bc0 100644
--- a/board/davinci/dm355evm/Kconfig
+++ b/board/davinci/dm355evm/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_DM355EVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "dm355evm"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_dm355evm"
diff --git a/board/davinci/dm355leopard/Kconfig b/board/davinci/dm355leopard/Kconfig
index 345704f..73a53ff 100644
--- a/board/davinci/dm355leopard/Kconfig
+++ b/board/davinci/dm355leopard/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_DM355LEOPARD
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "dm355leopard"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_dm355leopard"
diff --git a/board/davinci/dm365evm/Kconfig b/board/davinci/dm365evm/Kconfig
index d5f7ea2..266c6ee 100644
--- a/board/davinci/dm365evm/Kconfig
+++ b/board/davinci/dm365evm/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_DM365EVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "dm365evm"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_dm365evm"
diff --git a/board/davinci/dm6467evm/Kconfig b/board/davinci/dm6467evm/Kconfig
index f7b225d..1c4d0f0 100644
--- a/board/davinci/dm6467evm/Kconfig
+++ b/board/davinci/dm6467evm/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_DM6467EVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "dm6467evm"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_dm6467evm"
diff --git a/board/davinci/dvevm/Kconfig b/board/davinci/dvevm/Kconfig
index 7a2d86b..e020f8d 100644
--- a/board/davinci/dvevm/Kconfig
+++ b/board/davinci/dvevm/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_DVEVM
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "dvevm"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_dvevm"
diff --git a/board/davinci/ea20/Kconfig b/board/davinci/ea20/Kconfig
index afab821..93950fd 100644
--- a/board/davinci/ea20/Kconfig
+++ b/board/davinci/ea20/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_EA20
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "ea20"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "ea20"
diff --git a/board/davinci/schmoogie/Kconfig b/board/davinci/schmoogie/Kconfig
index 45401e4..7aa459d 100644
--- a/board/davinci/schmoogie/Kconfig
+++ b/board/davinci/schmoogie/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_SCHMOOGIE
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "schmoogie"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_schmoogie"
diff --git a/board/davinci/sffsdr/Kconfig b/board/davinci/sffsdr/Kconfig
index aeb7ef2..95461fc 100644
--- a/board/davinci/sffsdr/Kconfig
+++ b/board/davinci/sffsdr/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_SFFSDR
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "sffsdr"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_sffsdr"
diff --git a/board/davinci/sonata/Kconfig b/board/davinci/sonata/Kconfig
index 2cf5035..a21fb8e 100644
--- a/board/davinci/sonata/Kconfig
+++ b/board/davinci/sonata/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DAVINCI_SONATA
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "sonata"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "davinci"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "davinci_sonata"
diff --git a/board/enbw/enbw_cmc/Kconfig b/board/enbw/enbw_cmc/Kconfig
index e061e7e..183334b 100644
--- a/board/enbw/enbw_cmc/Kconfig
+++ b/board/enbw/enbw_cmc/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_ENBW_CMC
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "enbw_cmc"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "enbw"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "enbw_cmc"
diff --git a/board/omicron/calimain/Kconfig b/board/omicron/calimain/Kconfig
index 923af8a..46e95d8 100644
--- a/board/omicron/calimain/Kconfig
+++ b/board/omicron/calimain/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_CALIMAIN
 
-config SYS_CPU
-	string
-	default "arm926ejs"
-
 config SYS_BOARD
 	string
 	default "calimain"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "omicron"
 
-config SYS_SOC
-	string
-	default "davinci"
-
 config SYS_CONFIG_NAME
 	string
 	default "calimain"
diff --git a/configs/calimain_defconfig b/configs/calimain_defconfig
index a808ddf..02d3912 100644
--- a/configs/calimain_defconfig
+++ b/configs/calimain_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_CALIMAIN=y
diff --git a/configs/cam_enc_4xx_defconfig b/configs/cam_enc_4xx_defconfig
index 1417d83..dfdda82 100644
--- a/configs/cam_enc_4xx_defconfig
+++ b/configs/cam_enc_4xx_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_CAM_ENC_4XX=y
diff --git a/configs/da830evm_defconfig b/configs/da830evm_defconfig
index 49e74c3..d27cdb0 100644
--- a/configs/da830evm_defconfig
+++ b/configs/da830evm_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DA830EVM=y
diff --git a/configs/da850_am18xxevm_defconfig b/configs/da850_am18xxevm_defconfig
index af419ce..a79a0a8 100644
--- a/configs/da850_am18xxevm_defconfig
+++ b/configs/da850_am18xxevm_defconfig
@@ -1,4 +1,5 @@
 CONFIG_SPL=y
 CONFIG_SYS_EXTRA_OPTIONS="DA850_AM18X_EVM,MAC_ADDR_IN_EEPROM,SYS_I2C_EEPROM_ADDR_LEN=2,SYS_I2C_EEPROM_ADDR=0x50"
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_DA850EVM=y
diff --git a/configs/da850evm_defconfig b/configs/da850evm_defconfig
index 7517e92..afdce5e 100644
--- a/configs/da850evm_defconfig
+++ b/configs/da850evm_defconfig
@@ -1,4 +1,5 @@
 CONFIG_SPL=y
 CONFIG_SYS_EXTRA_OPTIONS="MAC_ADDR_IN_SPIFLASH"
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_DA850EVM=y
diff --git a/configs/da850evm_direct_nor_defconfig b/configs/da850evm_direct_nor_defconfig
index edc604a..25c303c 100644
--- a/configs/da850evm_direct_nor_defconfig
+++ b/configs/da850evm_direct_nor_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SYS_EXTRA_OPTIONS="MAC_ADDR_IN_SPIFLASH,USE_NOR,DIRECT_NOR_BOOT"
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DA850EVM=y
diff --git a/configs/davinci_dm355evm_defconfig b/configs/davinci_dm355evm_defconfig
index ef0b854..d3a03b2 100644
--- a/configs/davinci_dm355evm_defconfig
+++ b/configs/davinci_dm355evm_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DM355EVM=y
diff --git a/configs/davinci_dm355leopard_defconfig b/configs/davinci_dm355leopard_defconfig
index 22da9f3..875c0b5 100644
--- a/configs/davinci_dm355leopard_defconfig
+++ b/configs/davinci_dm355leopard_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DM355LEOPARD=y
diff --git a/configs/davinci_dm365evm_defconfig b/configs/davinci_dm365evm_defconfig
index dfae0b2..f841fd9 100644
--- a/configs/davinci_dm365evm_defconfig
+++ b/configs/davinci_dm365evm_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DM365EVM=y
diff --git a/configs/davinci_dm6467Tevm_defconfig b/configs/davinci_dm6467Tevm_defconfig
index e2c2de4..4523d4a 100644
--- a/configs/davinci_dm6467Tevm_defconfig
+++ b/configs/davinci_dm6467Tevm_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SYS_EXTRA_OPTIONS="DAVINCI_DM6467TEVM,REFCLK_FREQ=33000000"
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DM6467EVM=y
diff --git a/configs/davinci_dm6467evm_defconfig b/configs/davinci_dm6467evm_defconfig
index abd3491..5208257 100644
--- a/configs/davinci_dm6467evm_defconfig
+++ b/configs/davinci_dm6467evm_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SYS_EXTRA_OPTIONS="REFCLK_FREQ=27000000"
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DM6467EVM=y
diff --git a/configs/davinci_dvevm_defconfig b/configs/davinci_dvevm_defconfig
index eb53692..74e55b9 100644
--- a/configs/davinci_dvevm_defconfig
+++ b/configs/davinci_dvevm_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_DVEVM=y
diff --git a/configs/davinci_schmoogie_defconfig b/configs/davinci_schmoogie_defconfig
index bc166ab..64ed2c1 100644
--- a/configs/davinci_schmoogie_defconfig
+++ b/configs/davinci_schmoogie_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_SCHMOOGIE=y
diff --git a/configs/davinci_sffsdr_defconfig b/configs/davinci_sffsdr_defconfig
index ea9cf88..9eb0f07 100644
--- a/configs/davinci_sffsdr_defconfig
+++ b/configs/davinci_sffsdr_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_SFFSDR=y
diff --git a/configs/davinci_sonata_defconfig b/configs/davinci_sonata_defconfig
index 2c9cd4f..d8f0f77 100644
--- a/configs/davinci_sonata_defconfig
+++ b/configs/davinci_sonata_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_DAVINCI_SONATA=y
diff --git a/configs/ea20_defconfig b/configs/ea20_defconfig
index 562849d..93676cd 100644
--- a/configs/ea20_defconfig
+++ b/configs/ea20_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_EA20=y
diff --git a/configs/enbw_cmc_defconfig b/configs/enbw_cmc_defconfig
index 7fe405a..92c4926 100644
--- a/configs/enbw_cmc_defconfig
+++ b/configs/enbw_cmc_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
+CONFIG_ARCH_DAVINCI=y
 CONFIG_TARGET_ENBW_CMC=y
diff --git a/configs/hawkboard_defconfig b/configs/hawkboard_defconfig
index 9945fe5..4084f9c 100644
--- a/configs/hawkboard_defconfig
+++ b/configs/hawkboard_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_HAWKBOARD=y
diff --git a/configs/hawkboard_uart_defconfig b/configs/hawkboard_uart_defconfig
index b4db291..d7eeae7 100644
--- a/configs/hawkboard_uart_defconfig
+++ b/configs/hawkboard_uart_defconfig
@@ -1,4 +1,5 @@
 CONFIG_SPL=y
 CONFIG_SYS_EXTRA_OPTIONS="UART_U_BOOT"
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_HAWKBOARD=y
diff --git a/configs/ipam390_defconfig b/configs/ipam390_defconfig
index 6e95951..4fefcbe 100644
--- a/configs/ipam390_defconfig
+++ b/configs/ipam390_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_ARCH_DAVINCI=y
 +S:CONFIG_TARGET_IPAM390=y