diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index 812e8af..a288ee1 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -614,20 +614,8 @@ config TARGET_DRA7XX_EVM
 config TARGET_OMAP5_UEVM
 	bool "Support omap5_uevm"
 
-config TARGET_ARMADILLO_800EVA
-	bool "Support armadillo-800eva"
-
-config TARGET_KZM9G
-	bool "Support kzm9g"
-
-config TARGET_ALT
-	bool "Support alt"
-
-config TARGET_KOELSCH
-	bool "Support koelsch"
-
-config TARGET_LAGER
-	bool "Support lager"
+config RMOBILE
+	bool "Renesas ARM SoCs"
 
 config TARGET_S5P_GONI
 	bool "Support s5p_goni"
@@ -716,6 +704,8 @@ config TARGET_JORNADA
 
 endchoice
 
+source "arch/arm/cpu/armv7/rmobile/Kconfig"
+
 source "arch/arm/cpu/armv7/tegra-common/Kconfig"
 
 source "arch/arm/cpu/armv7/zynq/Kconfig"
@@ -750,7 +740,6 @@ source "board/armltd/integrator/Kconfig"
 source "board/armltd/versatile/Kconfig"
 source "board/armltd/vexpress/Kconfig"
 source "board/armltd/vexpress64/Kconfig"
-source "board/atmark-techno/armadillo-800eva/Kconfig"
 source "board/atmel/at91rm9200ek/Kconfig"
 source "board/atmel/at91sam9260ek/Kconfig"
 source "board/atmel/at91sam9261ek/Kconfig"
@@ -840,7 +829,6 @@ source "board/jornada/Kconfig"
 source "board/karo/tk71/Kconfig"
 source "board/karo/tx25/Kconfig"
 source "board/keymile/km_arm/Kconfig"
-source "board/kmc/kzm9g/Kconfig"
 source "board/logicpd/am3517evm/Kconfig"
 source "board/logicpd/imx27lite/Kconfig"
 source "board/logicpd/imx31_litekit/Kconfig"
@@ -861,9 +849,6 @@ source "board/ppcag/bg0900/Kconfig"
 source "board/pxa255_idp/Kconfig"
 source "board/raidsonic/ib62x0/Kconfig"
 source "board/raspberrypi/rpi_b/Kconfig"
-source "board/renesas/alt/Kconfig"
-source "board/renesas/koelsch/Kconfig"
-source "board/renesas/lager/Kconfig"
 source "board/ronetix/pm9261/Kconfig"
 source "board/ronetix/pm9263/Kconfig"
 source "board/ronetix/pm9g45/Kconfig"
diff --git a/arch/arm/cpu/armv7/rmobile/Kconfig b/arch/arm/cpu/armv7/rmobile/Kconfig
new file mode 100644
index 0000000..55c620a
--- /dev/null
+++ b/arch/arm/cpu/armv7/rmobile/Kconfig
@@ -0,0 +1,37 @@
+if RMOBILE
+
+choice
+	prompt "Renesus ARM SoCs board select"
+
+config TARGET_ARMADILLO_800EVA
+	bool "armadillo 800 eva board"
+
+config TARGET_KOELSCH
+	bool "Koelsch board"
+
+config TARGET_LAGER
+	bool "Lager board"
+
+config TARGET_KZM9G
+	bool "KZM9D board"
+
+config TARGET_ALT
+	bool "Alt board"
+
+endchoice
+
+config SYS_CPU
+	string
+	default "armv7"
+
+config SYS_SOC
+	string
+	default "rmobile"
+
+source "board/atmark-techno/armadillo-800eva/Kconfig"
+source "board/renesas/koelsch/Kconfig"
+source "board/renesas/lager/Kconfig"
+source "board/kmc/kzm9g/Kconfig"
+source "board/renesas/alt/Kconfig"
+
+endif
diff --git a/board/atmark-techno/armadillo-800eva/Kconfig b/board/atmark-techno/armadillo-800eva/Kconfig
index c8f89fe..3365c7b 100644
--- a/board/atmark-techno/armadillo-800eva/Kconfig
+++ b/board/atmark-techno/armadillo-800eva/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_ARMADILLO_800EVA
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "armadillo-800eva"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "atmark-techno"
 
-config SYS_SOC
-	string
-	default "rmobile"
-
 config SYS_CONFIG_NAME
 	string
 	default "armadillo-800eva"
diff --git a/board/kmc/kzm9g/Kconfig b/board/kmc/kzm9g/Kconfig
index 2d40173..ab4812f 100644
--- a/board/kmc/kzm9g/Kconfig
+++ b/board/kmc/kzm9g/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_KZM9G
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "kzm9g"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "kmc"
 
-config SYS_SOC
-	string
-	default "rmobile"
-
 config SYS_CONFIG_NAME
 	string
 	default "kzm9g"
diff --git a/board/renesas/alt/Kconfig b/board/renesas/alt/Kconfig
index d317025..dc01a38 100644
--- a/board/renesas/alt/Kconfig
+++ b/board/renesas/alt/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_ALT
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "alt"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "renesas"
 
-config SYS_SOC
-	string
-	default "rmobile"
-
 config SYS_CONFIG_NAME
 	string
 	default "alt"
diff --git a/board/renesas/koelsch/Kconfig b/board/renesas/koelsch/Kconfig
index 0def847..e7c6437 100644
--- a/board/renesas/koelsch/Kconfig
+++ b/board/renesas/koelsch/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_KOELSCH
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "koelsch"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "renesas"
 
-config SYS_SOC
-	string
-	default "rmobile"
-
 config SYS_CONFIG_NAME
 	string
 	default "koelsch"
diff --git a/board/renesas/lager/Kconfig b/board/renesas/lager/Kconfig
index e88f4f6..07dc98c 100644
--- a/board/renesas/lager/Kconfig
+++ b/board/renesas/lager/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_LAGER
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "lager"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "renesas"
 
-config SYS_SOC
-	string
-	default "rmobile"
-
 config SYS_CONFIG_NAME
 	string
 	default "lager"
diff --git a/configs/alt_defconfig b/configs/alt_defconfig
index 11a1c89..0655e60 100644
--- a/configs/alt_defconfig
+++ b/configs/alt_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
++S:CONFIG_RMOBILE=y
 CONFIG_TARGET_ALT=y
diff --git a/configs/armadillo-800eva_defconfig b/configs/armadillo-800eva_defconfig
index 081c88a..9b17895 100644
--- a/configs/armadillo-800eva_defconfig
+++ b/configs/armadillo-800eva_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
++S:CONFIG_RMOBILE=y
 CONFIG_TARGET_ARMADILLO_800EVA=y
diff --git a/configs/koelsch_defconfig b/configs/koelsch_defconfig
index d63a286..d59ff3d 100644
--- a/configs/koelsch_defconfig
+++ b/configs/koelsch_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
++S:CONFIG_RMOBILE=y
 CONFIG_TARGET_KOELSCH=y
diff --git a/configs/kzm9g_defconfig b/configs/kzm9g_defconfig
index aaddf82..d4d340f 100644
--- a/configs/kzm9g_defconfig
+++ b/configs/kzm9g_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
++S:CONFIG_RMOBILE=y
 CONFIG_TARGET_KZM9G=y
diff --git a/configs/lager_defconfig b/configs/lager_defconfig
index bf1be72..9a32d6b 100644
--- a/configs/lager_defconfig
+++ b/configs/lager_defconfig
@@ -1,2 +1,3 @@
 CONFIG_ARM=y
++S:CONFIG_RMOBILE=y
 CONFIG_TARGET_LAGER=y
diff --git a/include/configs/alt.h b/include/configs/alt.h
index 9eec4bc..7238f68 100644
--- a/include/configs/alt.h
+++ b/include/configs/alt.h
@@ -13,7 +13,6 @@
 #undef DEBUG
 #define CONFIG_ARMV7
 #define CONFIG_R8A7794
-#define CONFIG_RMOBILE
 #define CONFIG_RMOBILE_BOARD_STRING "Alt"
 #define CONFIG_SH_GPIO_PFC
 
diff --git a/include/configs/armadillo-800eva.h b/include/configs/armadillo-800eva.h
index 8bb932c..b073b97 100644
--- a/include/configs/armadillo-800eva.h
+++ b/include/configs/armadillo-800eva.h
@@ -12,7 +12,6 @@
 #undef DEBUG
 #define CONFIG_ARMV7
 #define CONFIG_R8A7740
-#define CONFIG_RMOBILE
 #define CONFIG_RMOBILE_BOARD_STRING "Armadillo-800EVA Board\n"
 #define CONFIG_SH_GPIO_PFC
 
diff --git a/include/configs/koelsch.h b/include/configs/koelsch.h
index 6795f28..ffb1c3b 100644
--- a/include/configs/koelsch.h
+++ b/include/configs/koelsch.h
@@ -12,7 +12,6 @@
 #undef DEBUG
 #define CONFIG_ARMV7
 #define CONFIG_R8A7791
-#define CONFIG_RMOBILE
 #define CONFIG_RMOBILE_BOARD_STRING "Koelsch"
 #define CONFIG_SH_GPIO_PFC
 
diff --git a/include/configs/kzm9g.h b/include/configs/kzm9g.h
index 5a13ad1..ac74ae7 100644
--- a/include/configs/kzm9g.h
+++ b/include/configs/kzm9g.h
@@ -10,7 +10,6 @@
 
 #undef DEBUG
 
-#define CONFIG_RMOBILE
 #define CONFIG_SH73A0
 #define CONFIG_KZM_A9_GT
 #define CONFIG_RMOBILE_BOARD_STRING	"KMC KZM-A9-GT"
diff --git a/include/configs/lager.h b/include/configs/lager.h
index f39a788..8ec268b 100644
--- a/include/configs/lager.h
+++ b/include/configs/lager.h
@@ -13,7 +13,6 @@
 #undef DEBUG
 #define CONFIG_ARMV7
 #define CONFIG_R8A7790
-#define CONFIG_RMOBILE
 #define CONFIG_RMOBILE_BOARD_STRING "Lager"
 #define CONFIG_SH_GPIO_PFC
 