diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index 837110d..cb24aed 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -409,14 +409,8 @@ config TARGET_HUMMINGBOARD
 config OMAP34XX
 	bool "OMAP34XX SoC"
 
-config TARGET_DUOVERO
-	bool "Support duovero"
-
-config TARGET_OMAP4_PANDA
-	bool "Support omap4_panda"
-
-config TARGET_OMAP4_SDP4430
-	bool "Support omap4_sdp4430"
+config OMAP44XX
+	bool "OMAP44XX SoC"
 
 config TARGET_CM_T54
 	bool "Support cm_t54"
@@ -525,6 +519,8 @@ source "arch/arm/cpu/arm926ejs/kirkwood/Kconfig"
 
 source "arch/arm/cpu/armv7/omap3/Kconfig"
 
+source "arch/arm/cpu/armv7/omap4/Kconfig"
+
 source "arch/arm/cpu/armv7/rmobile/Kconfig"
 
 source "arch/arm/cpu/armv7/tegra-common/Kconfig"
@@ -607,7 +603,6 @@ source "board/freescale/mx6sxsabresd/Kconfig"
 source "board/freescale/vf610twr/Kconfig"
 source "board/gateworks/gw_ventana/Kconfig"
 source "board/genesi/mx51_efikamx/Kconfig"
-source "board/gumstix/duovero/Kconfig"
 source "board/gumstix/pepper/Kconfig"
 source "board/h2200/Kconfig"
 source "board/hale/tt01/Kconfig"
@@ -661,8 +656,6 @@ source "board/ti/am43xx/Kconfig"
 source "board/ti/dra7xx/Kconfig"
 source "board/ti/ks2_evm/Kconfig"
 source "board/ti/omap5_uevm/Kconfig"
-source "board/ti/panda/Kconfig"
-source "board/ti/sdp4430/Kconfig"
 source "board/ti/ti814x/Kconfig"
 source "board/ti/ti816x/Kconfig"
 source "board/ti/tnetv107xevm/Kconfig"
diff --git a/arch/arm/cpu/armv7/omap4/Kconfig b/arch/arm/cpu/armv7/omap4/Kconfig
new file mode 100644
index 0000000..20d2c11
--- /dev/null
+++ b/arch/arm/cpu/armv7/omap4/Kconfig
@@ -0,0 +1,29 @@
+if OMAP44XX
+
+choice
+	prompt "OMAP4 board select"
+
+config TARGET_DUOVERO
+	bool "OMAP4430 Gumstix Duovero"
+
+config TARGET_OMAP4_PANDA
+	bool "TI OMAP4 PandaBoard"
+
+config TARGET_OMAP4_SDP4430
+	bool "TI OMAP4 SDP4430"
+
+endchoice
+
+config SYS_CPU
+	string
+	default "armv7"
+
+config SYS_SOC
+	string
+	default "omap4"
+
+source "board/gumstix/duovero/Kconfig"
+source "board/ti/panda/Kconfig"
+source "board/ti/sdp4430/Kconfig"
+
+endif
diff --git a/board/gumstix/duovero/Kconfig b/board/gumstix/duovero/Kconfig
index d1b5c66..f662798 100644
--- a/board/gumstix/duovero/Kconfig
+++ b/board/gumstix/duovero/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_DUOVERO
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "duovero"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "gumstix"
 
-config SYS_SOC
-	string
-	default "omap4"
-
 config SYS_CONFIG_NAME
 	string
 	default "duovero"
diff --git a/board/ti/panda/Kconfig b/board/ti/panda/Kconfig
index be1307d..b69218b 100644
--- a/board/ti/panda/Kconfig
+++ b/board/ti/panda/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_OMAP4_PANDA
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "panda"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "ti"
 
-config SYS_SOC
-	string
-	default "omap4"
-
 config SYS_CONFIG_NAME
 	string
 	default "omap4_panda"
diff --git a/board/ti/sdp4430/Kconfig b/board/ti/sdp4430/Kconfig
index 140e1f1..9c1d8fe 100644
--- a/board/ti/sdp4430/Kconfig
+++ b/board/ti/sdp4430/Kconfig
@@ -1,9 +1,5 @@
 if TARGET_OMAP4_SDP4430
 
-config SYS_CPU
-	string
-	default "armv7"
-
 config SYS_BOARD
 	string
 	default "sdp4430"
@@ -12,10 +8,6 @@ config SYS_VENDOR
 	string
 	default "ti"
 
-config SYS_SOC
-	string
-	default "omap4"
-
 config SYS_CONFIG_NAME
 	string
 	default "omap4_sdp4430"
diff --git a/configs/duovero_defconfig b/configs/duovero_defconfig
index b56092a..8591845 100644
--- a/configs/duovero_defconfig
+++ b/configs/duovero_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_OMAP44XX=y
 +S:CONFIG_TARGET_DUOVERO=y
diff --git a/configs/omap4_panda_defconfig b/configs/omap4_panda_defconfig
index 1498d17..6afac38 100644
--- a/configs/omap4_panda_defconfig
+++ b/configs/omap4_panda_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_OMAP44XX=y
 +S:CONFIG_TARGET_OMAP4_PANDA=y
diff --git a/configs/omap4_sdp4430_defconfig b/configs/omap4_sdp4430_defconfig
index faac317..c771e76 100644
--- a/configs/omap4_sdp4430_defconfig
+++ b/configs/omap4_sdp4430_defconfig
@@ -1,3 +1,4 @@
 CONFIG_SPL=y
 +S:CONFIG_ARM=y
++S:CONFIG_OMAP44XX=y
 +S:CONFIG_TARGET_OMAP4_SDP4430=y
diff --git a/include/configs/ti_omap4_common.h b/include/configs/ti_omap4_common.h
index 30b02f6..8c7310c 100644
--- a/include/configs/ti_omap4_common.h
+++ b/include/configs/ti_omap4_common.h
@@ -15,7 +15,6 @@
 /*
  * High Level Configuration Options
  */
-#define CONFIG_OMAP44XX		1	/* which is a 44XX */
 #define CONFIG_OMAP4430		1	/* which is in a 4430 */
 #define CONFIG_MISC_INIT_R
 #define CONFIG_ARCH_CPU_INIT